freeslot("S_COPY_PARTICLE1", "S_COPY_PARTICLE2", "S_COPY_PARTICLE3", "S_COPY_PARTICLE4", "S_COPY_PARTICLE5", "S_COPY_PARTICLE6", "MT_COPY_PARTICLE1", "sfx_incopy", "sfx_decopy")

states[S_COPY_PARTICLE1] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = A,
	nextstate = S_COPY_PARTICLE2
}

states[S_COPY_PARTICLE2] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = B,
	nextstate = S_COPY_PARTICLE3
}

states[S_COPY_PARTICLE3] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = C,
	nextstate = S_COPY_PARTICLE4
}

states[S_COPY_PARTICLE4] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = D,
	nextstate = S_COPY_PARTICLE5
}

states[S_COPY_PARTICLE5] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = E,
	nextstate = S_COPY_PARTICLE6
}

states[S_COPY_PARTICLE6] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = F,

}

mobjinfo[MT_COPY_PARTICLE1] = {
	spawnstate = S_COPY_PARTICLE1,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT
}



-- used for debugging scenarios, did its job, leaving it here, free to chill
local function DITTO_log(msg)
	print("[DITTO] "..msg)
end


--woaaaaa
local DITTO_SKIN='ditto'

-- we all know this one... right?
local GO_TIME= 6 * TICRATE + (3 * TICRATE / 4)

-- all the arbitrary gameplay parameters I decided.
local BASE_TRANSFORM_TIME= 15*TICRATE
local MIN_TRANSFORM_TIME= 7*TICRATE
local TRANFORMING_DURATION= 3*TICRATE

local START_TRANSFORM_TIMEMARK= 4*TICRATE
local ENDRACE_DETRANSFORM_TIME= 2*TICRATE

local RETAIN_MEMORY_DISTANCE= 2000*FRACUNIT
local COPY_ENABLED_DISTANCE= 1000*FRACUNIT

-- this is usefull in case the 'copy_once' setting is active
local nb_copies= O


-- this calls the transforming effects on a given mobj.
-- also takes the sfx sound to play during the transformation.
-- if nothing ('nil') is given, it'll play the 'sfx_incopy' sound
local function _copyFX(pmo, sfx)
	sfx= $ or sfx_incopy

	local qsfx= (sfx==sfx_incopy and sfx_decopy or sfx_incopy)
	
	local copy_particle = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_COPY_PARTICLE1)
	copy_particle.angle = pmo.angle
	copy_particle.target = pmo
	if (S_SoundPlaying(pmo, qsfx)) then
		S_StopSoundByID(pmo, qsfx)
	end
	S_StartSound(pmo, sfx)	
end

-- yeah, it kind of bothers me that we have to go through the players iteration loop
-- everytime we need the number of players, so I figured we at least could only do it
-- only once a frame (although now that I think about it, it's not even usefull in this
-- script… SHIT!)
local _countedPlayers= nil
local function countNonSpecPlayers()
	if _countedPlayers~= nil return _countedPlayers end
    local n = 0
    for p in players.iterate do
		if (not p.spectator) and p.mo then n = $+1 end
    end
	_countedPlayers= n
    return n
end

-- tells if a player's... yeah the function name says it all...
local function finished(p)
	return (not p.spectator) and p.mo and ((p.pflags & PF_TIMEOVER) or p.exiting) 
end


-- tells if a particular targeted player is copyable by a ditto (that's the character I'm
-- making here, remember?)
local function canCopy(target_p)
	return ((not target_p.spectator) and (not target_p.exiting) and target_p.mo and
			target_p.playerstate~=PST_DEAD and target_p.mo.skin~=DITTO_SKIN) and
			(not target_p.kartstuff[k_hyudorotimer]) and
			(G_RaceGametype() or target_p.kartstuff[k_bumper]>0 or
				(server.ditto_server_config and server.ditto_server_config.base~=nil
					and (server.ditto_server_config.base & DITTO_CONFIG.BATTLE_COPY_DEADPLAYERS)
				)
			)
end

-- the function that transforms a ditto player into another.
-- if boolean parameter 'fx' is not given (or if 'fx==true')
-- then the transformation effects and sound will be called upon
-- the transfroming players, otherwise (if 'fx==false'), player will
-- transform quietly
local function playerCopies(ditto_p, target_p, fx)
	fx= (fx==nil) and true or fx

	if (ditto_p.ditto_config & DITTO_CONFIG.TRANFORM_ONLY_ONCE) and nb_copies>0 then return end 

	-- with or without sparkles and shit?
	if fx then
		_copyFX(ditto_p.mo)
	end

	-- will the transformed ditto keep its original color?
	-- (depends on 'keep_color' setting, and also friendmod (if present)
	--  and the associated 'ignore_team' setting)
	local b_keepColor= (
		( ditto_p.ditto_config & DITTO_CONFIG.KEEP_COLOR )
		or ( FRIENDMOD_CheckTeams and FRIENDMOD_CheckTeams() and not (ditto_p.ditto_config & DITTO_CONFIG.FRIENDMOD_IGNORE_TEAM_COLOR) )
	)
	
	-- moon crystal power! make u-... wait no, wrong character...
	ditto_p.mo.skin= target_p.mo.skin
	
	-- anyway, this where we make all the changes and save all the relevant settings and whatnot
	ditto_p.is_actually_a_ditto= $ or {}
	ditto_p.is_actually_a_ditto.original_color= ($) or ditto_p.skincolor
	ditto_p.is_actually_a_ditto.transform_time= BASE_TRANSFORM_TIME
	ditto_p.is_actually_a_ditto.copied_target= target_p
	ditto_p.is_actually_a_ditto.copied_skin= target_p.mo.skin
	ditto_p.is_actually_a_ditto.copied_color= (b_keepColor) and ditto_p.skincolor or target_p.skincolor

	ditto_p.is_actually_a_ditto.copying_target= nil
	ditto_p.is_actually_a_ditto.transform_progress= 0
	ditto_p.is_actually_a_ditto.real_transform_time= 0
	
	if not b_keepColor then
		ditto_p.skincolor= target_p.skincolor
		ditto_p.mo.color= target_p.skincolor
	end
	
	-- gotta deal with hostmod's restat
	-- which simple presence locks the character stats
	local cv_restat= CV_FindVar("hm_restat")
	local restat=  (cv_restat and cv_restat.value)
	if not restat then
		ditto_p.kartspeed= target_p.kartspeed
		ditto_p.kartweight= target_p.kartweight
	else
		ditto_p.is_actually_a_ditto.special= $ or {}
		ditto_p.is_actually_a_ditto.special.hm_restat= {ditto_p.HMRs, ditto_p.HMRw}
		
		-- oh yeah, there's the 'keep_restat' seeting to keep ditto's restat (laaaame)
		if (not (ditto_p.ditto_config & DITTO_CONFIG.KEEP_HM_RESTAT)) or (not ditto_p.HMRs) then
			ditto_p.HMRs= target_p.kartspeed
			ditto_p.HMRw= target_p.kartweight
		end
	end
	
	-- hornmod
	if HORNMOD then
		local dhm= ditto_p.hornmod
		if dhm and dhm.horn then
			ditto_p.is_actually_a_ditto.special= $ or {}
			ditto_p.is_actually_a_ditto.special.horn= dhm.horn
		end
		
		if dhm and target_p.hornmod.horn then
			dhm.horn= target_p.hornmod.horn
		end
	end
	
	-- emotes
	if EMOJI_TIME then
		if ditto_p.emoteCustomTable then
			ditto_p.is_actually_a_ditto.special= $ or {}
			ditto_p.is_actually_a_ditto.special.emotes= ditto_p.emoteCustomTable
		end
		
		if target_p.emoteCustomTable then
			ditto_p.emoteCustomTable= target_p.emoteCustomTable
		end
	end

	--secondcolor
	if target_p.ksc_secondcolor~=nil then
		if b_keepColor then
			ditto_p.ksc_secondcolor= ditto_p.is_actually_a_ditto.original_color
		else
			ditto_p.ksc_secondcolor= target_p.ksc_secondcolor
		end
	end

	nb_copies= $+1
end

-- ditto players copies another player randomly (among a list of candidates)
local function playerRandomlyCopies(ditto_p, candidates)
	local t_c= countNonSpecPlayers()
	if t_c==1 then return end
	
	
	local target_p= nil
	if (not candidates or #candidates<=0) then
		local r_n= P_RandomRange(0, (t_c-2))
		
		local t_p= #players
		local j= 0
		for i=0,(t_p-1) do
			local p= players[i]
			if p~=ditto_p and p and p.mo and (not p.spectator) then
				if (not canCopy(p)) then continue end
				target_p= p
				if j==r_n then break end
				j= ($<r_n) and ($+1) or r_n
			end
		end
	else
		t_c= #candidates
		local r_n= P_RandomRange(0, (t_c-1))
		
		for i=0,(t_c-1) do
			local p= candidates[((r_n+i)%t_c)+1]
			if (not canCopy(p)) then continue end
			target_p= p
		end
		
	end
	
	
	if target_p then
		playerCopies(ditto_p, target_p)
	end
end

-- go back! go back!
-- the transformed ditto goes back to it form squishy self
-- (again with 'fx' or not)
-- if flush left to 'nil' (or false), the transformation
--   progress and target will saved,
--   if set to 'true' everything will be cleared
local function playerDetransforms(ditto_p, fx, flush)
	fx= (fx==nil) or fx
	
	if ditto_p.mo and ditto_p.is_actually_a_ditto then
		if fx and not ditto_p.spectator then
			_copyFX(ditto_p.mo, sfx_decopy)
		end
		
		ditto_p.is_actually_a_ditto.transform_time= 0
		
		local _c= ditto_p.is_actually_a_ditto.original_color
		if _c then
			ditto_p.skincolor= _c
			ditto_p.mo.color= _c
		end
		
		
		local spe= ditto_p.is_actually_a_ditto.special
		
		local cv_restat= CV_FindVar("hm_restat")
		local restat=  (cv_restat and cv_restat.value)
		if not restat then
			local v= skins[DITTO_SKIN]
			ditto_p.kartspeed= v.kartspeed
			ditto_p.kartweight= v.kartweight
		-- so, if restat is active we might have tampered with the
		--  restat's stats... should put them back
		else
			if spe and spe.hm_restat and #(spe.hm_restat)>0 then
				ditto_p.HMRs= spe.hm_restat[1]
				ditto_p.HMRw= spe.hm_restat[(#(spe.hm_restat)>1) and 2 or 1]
			end
		end
		
		-- horn stuff
		if HORNMOD and spe and spe.horn and ditto_p.hornmod then
			ditto_p.hornmod.horn= spe.horn
		end
		
		-- emotes
		if EMOJI_TIME and spe and spe.emotes then
			ditto_p.emoteCustomTable= spe.emotes
		end

		-- secondcolor
		ditto_p.ksc_secondcolor= nil
		
		
		ditto_p.mo.skin= DITTO_SKIN
		ditto_p.is_actually_a_ditto=
			flush and {} 
				or {
						-- keep these, just in case a copy was in progress when ditto detransformed
						transform_progress= ditto_p.is_actually_a_ditto.transform_progress,
						copying_target= ditto_p.is_actually_a_ditto.copying_target
					}
	end
end

-- the is a ditto among us!
local function isPlayerTransformedDitto(ditto_p)
	return (ditto_p.is_actually_a_ditto and ditto_p.mo and ditto_p.mo.skin~=DITTO_SKIN)
end




-- are two transformation targets equivalent? (not equal, equivalent)?
-- considering there might be other dittos and shit
local function _target_eq(t1, t2)
	return
		(t1==t2
			or (t1 and t1.is_actually_a_ditto
				and t1.is_actually_a_ditto.copied_target==t2
			) or (t2 and t2.is_actually_a_ditto
				and t2.is_actually_a_ditto.copied_target==t1
			)
		) and (t1==nil or t2==nil or t1.mo.skin==t2.mo.skin)
		
end

-- this is used later, for the HUD
-- (to check if transfo timer is approaching or go fleeing it's end)
local _tPrev=MIN_TRANSFORM_TIME

-- ah, this be the function that handles a ditto player transformation
-- according to its envrionnement
local function lookAroundForTransformation(ditto_p)
	local min_distance= (-1)
	local closest_p= nil
	local cur_target_distance= (-1)
	local copying_target_distance= (-1)
	local ditto_prop= ditto_p.is_actually_a_ditto
	-- yeah, so we make one quick loop through the players and try to find the nearest target,
	-- and compue all the relevant distances
	for other_p in players.iterate do
		if other_p==ditto_p or not canCopy(other_p) then continue end

		local d= R_PointToDist2(ditto_p.mo.x, ditto_p.mo.y, other_p.mo.x, other_p.mo.y)

		if _target_eq(other_p, ditto_prop.copied_target) then
			cur_target_distance= d
		end
		
		if _target_eq(other_p, ditto_prop.copying_target)
			copying_target_distance= d
		end

		if (d>0 and (d<min_distance or min_distance<0) and d<=COPY_ENABLED_DISTANCE) then
			min_distance= d
			closest_p= other_p
		end
	end

	local b_transformed= isPlayerTransformedDitto(ditto_p)


	_tPrev= ditto_prop.transform_time
	-- been transormet for how long, bro?
	ditto_prop.real_transform_time= b_transformed and $+1 or 0

	-- if the guy we copied is still in range and/or the closest
	-- ('closest' also means he's necessarily in copy range, mind you)
	-- then the transform time count down increases, and any started
	-- re-transformation process fades away
	if (cur_target_distance>=0 and cur_target_distance<=COPY_ENABLED_DISTANCE)
		or (closest_p and _target_eq(closest_p, ditto_prop.copied_target))
	then 
		ditto_prop.transform_time= ($>=BASE_TRANSFORM_TIME and BASE_TRANSFORM_TIME or ($+1))
		ditto_prop.transform_progress= ($>0) and ($-1) or 0
		return
	end

	-- if the transfromed ditto's previously copied traget is still in range, increase the
	--  transfrom time countdown, otherwise decrease.
	if b_transformed then
		ditto_prop.transform_time= (cur_target_distance>=0 and cur_target_distance<=RETAIN_MEMORY_DISTANCE)
									and	(cur_target_distance<=COPY_ENABLED_DISTANCE 
											and ($>=BASE_TRANSFORM_TIME and BASE_TRANSFORM_TIME or ($+1))
											or $
										)
									or ( $>0 and ($-1) or 0 )
		-- oh yeah, and there's a minimum amount of time a ditto stays transformed,
		--  so if we haven't reached that, abort anything else
		if ditto_prop.real_transform_time<MIN_TRANSFORM_TIME then return end
	-- else
	-- 	-- oh! and this is if the 'no_random' settings is on, it means we didn't
	-- 	--  randomly transfromed at the start, wo we're here now and just transforme to the
	-- 	--  closest guys (hopefully)
	-- 	if(leveltime==START_TRANSFORM_TIMEMARK+1) and closest_p then
	-- 		playerCopies(ditto_p, closest_p)
	-- 	end
	end

	-- if there's a new target in range (closest), we update the transforming gauge
	--  and if there's not we just decrease is it until it reaches 0
	if ditto_prop.copying_target and (not _target_eq(ditto_prop.copying_target, ditto_prop.copied_target))
		and _target_eq(ditto_prop.copying_target, closest_p)
	then
		ditto_prop.transform_progress= $+1
	else
		if closest_p then
			ditto_prop.transform_progress= 0
			ditto_prop.copying_target= closest_p
		elseif ditto_prop.copying_target then
			ditto_prop.transform_progress= ($~=nil and $>0) and ($-1) or 0
			ditto_prop.copying_target= (ditto_prop.transform_progress>0) and $ or nil 
		end
	end

	-- if the transform count down reaches 0, the players detransforms
	if ditto_prop.transform_time==0 then
		-- (this is to try and avoid player detransforming and retransform over under a second)
		if ditto_prop.transform_progress>=(TRANFORMING_DURATION-(TICRATE/2)) then
			ditto_prop.transform_time= 1
		else
			playerDetransforms(ditto_p)
			
			return
		end
	end

	-- if the transforming gauge is full, leave our old self behind and
	-- embrace our new, not even final form
	if ditto_prop.transform_progress~=nil and ditto_prop.transform_progress>=TRANFORMING_DURATION 
		and leveltime>GO_TIME
	then
		playerDetransforms(ditto_p, false)
		playerCopies(ditto_p,ditto_prop.copying_target)
	end
end



-- I'm paranoid, this a litte system to make sure relevant stuff
--  will be flushed out between various state (race, intermission, vote, etc.)
local _cleaning= 0
local function cleaning(lvl)
	if _cleaning==lvl then return end
	
	for player in players.iterate do
		if isPlayerTransformedDitto(player) then
			playerDetransforms(player, false, true)
		end
		
		player.is_actually_a_ditto= nil
	end
	_cleaning= lvl
end

-- and here it is, the 'thinkFrame' hook!
-- where all the rage is at...
addHook ("ThinkFrame", function()
	_countedPlayers= nil
	
	-- we pick up all the candidates for the 'copy random player at start' bit
	local copyCandidates=nil
	if leveltime==START_TRANSFORM_TIMEMARK then
		copyCandidates= {}
		for player in players.iterate do
			if canCopy(player) then
				table.insert(copyCandidates,player)
			end
		end
		nb_copies= 0
	end

	-- here we go, the main player loop, everyone should get their due
	for player in players.iterate do
		-- hopefully it'll be initialized soon...
		if player.ditto_config==nil or (not (player.ditto_config & DITTO_CONFIG.INITIAL_CHECK)) then continue end
		
		-- make sure we have a fresh start
		if leveltime==1 then
			playerDetransforms(player, false, true)
			player.is_actually_a_ditto= nil
			
			-- trying to make things work nicely with HOSTMOD's restat
			-- (hope I'm not making things worse though, lol)
			if player.HMRs and 
				player.HMRs_p != player.HMRs or player.HMRw_p != player.HMRw
			then
				player.HMRs = player.HMRs_p
				player.HMRw = player.HMRw_p				
			end
		end
		
		-- chill, nothing to do until then
		if (leveltime<START_TRANSFORM_TIMEMARK) or
			player.spectator or (not player.mo)
		then
			continue
		end
		
		local pmo_cur_skin= player.mo.skin
		
		-- dittos get ditto stuff, man
		if pmo_cur_skin==DITTO_SKIN and not player.is_actually_a_ditto then
			player.is_actually_a_ditto= {}
		end
		
		-- sorry, this hook be dittos only
		if not player.is_actually_a_ditto then continue end
		
		-- make sure there's not dumb stuff at respawn
		if player.kartstuff[k_respawn] and
			player.is_actually_a_ditto.transform_time and pmo_cur_skin~=player.is_actually_a_ditto.copied_skin
		then
			player.mo.skin= player.is_actually_a_ditto.copied_skin or $
		end
	
		-- let's go! if the 'no_random' setting isn't on, random copy stuff
		if leveltime==START_TRANSFORM_TIMEMARK and not (player.ditto_config & DITTO_CONFIG.DONT_START_RANDOM) then
			playerRandomlyCopies(player, copyCandidates)
			
			continue
		end
		
		-- so you're a transformed ditto, huh?
		-- yeah, please don't switch back to the ditto skin nor change you color
		--  manually... this isn't how it's supposed to work bro
		if player.is_actually_a_ditto.transform_time then
			if pmo_cur_skin==DITTO_SKIN then
				player.mo.skin= player.is_actually_a_ditto.copied_skin or $
			end
			
			if player.is_actually_a_ditto.copied_color~=player.skincolor then
				player.is_actually_a_ditto.original_color= player.skincolor
				player.mo.color= player.is_actually_a_ditto.copied_color or $
				player.skincolor= player.mo.color
			end
		end
		
		-- oh, so you're changing to a completely unrelated skin?
		--  yeah get out of here!
		if pmo_cur_skin~=DITTO_SKIN and pmo_cur_skin~=player.is_actually_a_ditto.copied_skin then
			player.mo.color= player.skincolor
			
			playerDetransforms(player, false, true)
			player.mo.skin= pmo_cur_skin
			
			player.is_actually_a_ditto= nil
			
			continue
		end
		
		-- you dead bro? well what can I do, heh?
		if (player.playerstate==PST_DEAD) then continue end

		-- so you're all done?  well de-transform, play dumb sounds or whatever
		if finished(player) then
			if isPlayerTransformedDitto(player) then
				player.is_actually_a_ditto.transform_time= ($>ENDRACE_DETRANSFORM_TIME) and (ENDRACE_DETRANSFORM_TIME-1)
																or (($>0) and ($-1) or 0)
				
				if player.is_actually_a_ditto.transform_time<1 then
					local _sW= skins[pmo_cur_skin].soundsid[SKSKWIN]
					local _sL= skins[pmo_cur_skin].soundsid[SKSKLOSE]
					if (S_SoundPlaying(player.mo, _sW)) then
						S_StopSoundByID(player.mo, _sW)
					elseif (S_SoundPlaying(player.mo, _sL)) then
						S_StopSoundByID(player.mo, _sL)
					elseif (S_IdPlaying(_sW)) then
						-- yeah I'm trying this because you can't S_StopSound global sounds lmao! ... =_='
						-- [spoiler: doesn't work]
						sfxinfo[_sW].singular= true
						S_StartSoundAtVolume(nil, _sW, 0)
					elseif (S_IdPlaying(_sL)) then
						sfxinfo[_sL].singular= true
						S_StartSoundAtVolume(nil, _sL, 0)
					end
				end
				if player.is_actually_a_ditto.transform_time<=0 then
					playerDetransforms(player, true, true)
					local np= countNonSpecPlayers()
					local soundNum= (player.kartstuff[k_position]>(np-np/2)) and SKSKLOSE or SKSKWIN
					if player==consoleplayer then
						S_StartSound(nil, skins[DITTO_SKIN].soundsid[soundNum])
					else
						S_StartSound(player.mo, skins[DITTO_SKIN].soundsid[soundNum])					
					end
				end
			end
		-- shit is on. Now, who to copy? hmmm...
		elseif (not ( (player.ditto_config & DITTO_CONFIG.TRANFORM_ONLY_ONCE) and nb_copies>0 ))
				and (leveltime>GO_TIME )
		then
			lookAroundForTransformation(player)
		end
	end
	
	_cleaning= 1
end)

addHook("IntermissionThinker", function()
	_countedPlayers= nil
	
	cleaning(2)
end)

addHook("VoteThinker", function()
	_countedPlayers= nil
	
	cleaning(3)
end)

-- the fx stuff, make sure it looks and sticks well
addHook ("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.target and mo.target.valid
			local p_target = mo.target
			P_TeleportMove(mo, p_target.x, p_target.y, p_target.z)
			mo.angle = p_target.angle
			mo.momx = p_target.momx
			mo.momy = p_target.momy
			mo.momz = p_target.momz
		end
		
	end
end, MT_COPY_PARTICLE1)



local R_GetScreenCoords= R_GetScreenCoords
if not R_GetScreenCoords then
	-- Thanks to Lat' for this function
	R_GetScreenCoords= function (v, p, c, mx, my, mz)
		local camx, camy, camz, camangle, camaiming
		if p.awayviewtics then
			camx = p.awayviewmobj.x
			camy = p.awayviewmobj.y
			camz = p.awayviewmobj.z
			camangle = p.awayviewmobj.angle
			camaiming = p.awayviewaiming
		elseif c.chase then
			camx = c.x
			camy = c.y
			camz = c.z
			camangle = c.angle
			camaiming = c.aiming
		else
			camx = p.mo.x
			camy = p.mo.y
			camz = p.viewz-20*FRACUNIT
			camangle = p.mo.angle
			camaiming = p.aiming
		end
	
		local x = camangle-R_PointToAngle2(camx, camy, mx, my)
	
		local distfact = cos(x)
		if not distfact then
			distfact = 1
		end
	
		if x > ANGLE_90 or x < ANGLE_270 then
			return -9, -9, 0
		else
			x = FixedMul(tan(x, true), 160<<FRACBITS)+160<<FRACBITS
		end
	
		local y = camz-mz
		y = FixedDiv(y, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)))
		y = (y*160)+(100<<FRACBITS)
		y = y+tan(camaiming, true)*160
	
		local scale = FixedDiv(160*FRACUNIT, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)))
	
		return x, y, scale
	end
end

--------
-- for debug stuff, don't worry about it
--  thanks for the help, rest well friend
local function dittoDebug_transfoDataHudDisplay(v,player)
	local ditto_prop= player.is_actually_a_ditto
	if not ditto_prop then return end

	local s= ""
	local ws= 0
	if ditto_prop.transform_time then
		s= "transfTime: "..ditto_prop.transform_time
		s= s .."("..((ditto_prop.copied_target and ditto_prop.copied_target.valid) and
			ditto_prop.copied_target.name or 'nil'
		)..')'
		ws= v.stringWidth(s, V_ALLOWLOWERCASE, "small")
		v.drawString(160-ws/2, 10, s, V_ALLOWLOWERCASE, "small")
	end
	if ditto_prop.real_transform_time then
		s= "realTime: "..ditto_prop.real_transform_time
		s= (ditto_prop.real_transform_time<MIN_TRANSFORM_TIME and "\x85" or "")..s
		ws= v.stringWidth(s, V_ALLOWLOWERCASE, "small")
		v.drawString(160-ws/2, 15, s, V_ALLOWLOWERCASE, "small")
	end
	if ditto_prop.transform_progress then
		s= "transfProgress: "..ditto_prop.transform_progress
		s= s.." ("..((ditto_prop.copying_target and ditto_prop.copying_target.valid) and
			ditto_prop.copying_target.name or 'nil'
		)..')'
		ws= v.stringWidth(s, V_ALLOWLOWERCASE, "small")
		v.drawString(160-ws/2, 20, s, V_ALLOWLOWERCASE, "small")
	end
end
------




-- yeah, I'm not sure tbh, don't care
--  (local HUD use only)
local function splitnum(p)
	-- yeah actually, original stuff didn't work
	-- this does the trick, go figure...
	local i=0
	for dp in displayplayers.iterate do
		if dp==p then
			return i
		end
		i= $+1
	end

	return 0
end


-- we'll put the sprites of the HUD transfo indicators in here
local a_copyIndicator= nil

-- drawing the transformation cues on the HUD, y'a know?
local function drawCopyProgress(v, p, c)
	local copyProgress= p.is_actually_a_ditto.transform_progress
	local transform_time= p.is_actually_a_ditto.transform_time
	local real_time= p.is_actually_a_ditto.real_transform_time

	-----
	-- Yeah, the following stuff is code I borrowed from Lat's driftgauge
	--  really saved me a lot of trouble! Hats off to the guy
	-----
	local zpos = p.mo.z
	-- on reverse grav, we want z to be "under" still, aka above
	if p.mo.eflags & MFE_VERTICALFLIP and not (p.pflags & PF_FLIPCAM)
		-- reminder that you're a lame ass for using flipcam
		zpos = p.mo.z + p.mo.height
	end

	local basex,basey = R_GetScreenCoords(v, p, c, p.mo.x, p.mo.y, zpos)

	local splitflags = 0

	local xdiv, ydiv= 1, 1
	if splitscreen == 1	-- 2 players
		ydiv= 2

		basey = $/2
		if splitnum(p)
			splitflags = V_SPLITSCREEN --|V_SNAPTOBOTTOM
		end
	elseif splitscreen > 1	-- 3 or 4 players
		xdiv, ydiv= 2, 2	

		basex = $/2
		basey = $/2

		if splitnum(p) == 1
			splitflags = V_HORZSCREEN
		elseif splitnum(p) == 2
			splitflags = V_SPLITSCREEN --|V_SNAPTOBOTTOM
		elseif splitnum(p) == 3
			splitflags = V_SPLITSCREEN|V_HORZSCREEN --|V_SNAPTOBOTTOM
		end
	end

	if encoremode
		basex = 320<<FRACBITS -$
	end

	local screen_x = (basex>>FRACBITS) 
	local screen_y = (basey>>FRACBITS) -30/ydiv
	

	-- now with the annoying stuff out of the ways,
	-- let's draw the 'transforming progress' sprite, if needed
	if copyProgress then

		local n_step= #a_copyIndicator
		if n_step== 0 then
			return
		end
		local pstep= (copyProgress/(TRANFORMING_DURATION/n_step)+1)
		pstep= (pstep>n_step) and n_step or $

		local colormap= nil
		local t= p.is_actually_a_ditto.copying_target
		if t and t.mo then
			colormap= v.getColormap(t.mo.skin, t.skincolor)
		end

		v.draw(screen_x, screen_y, a_copyIndicator[pstep], V_HUDTRANS | splitflags, colormap)
	elseif transform_time then
		_tPrev= ($~=nil) and _tPrev or 0 --this happened once, so fixing it here, lol
		-- or maybe draw the 'detransforming soon' cue?
		if transform_time<TRANFORMING_DURATION and (transform_time-_tPrev)<0 then
			local str=""
			local pstep= (transform_time/(TRANFORMING_DURATION/3)+1)
			pstep= (pstep>3) and 3 or pstep
			for i=3,1,(-1) do
				str= $..((i>=pstep) and '.' or ' ') 
			end
			local ws= v.stringWidth(str)
			v.drawString(screen_x-(ws/2), screen_y-(27/ydiv), str, splitflags)
		end
		
		-- also if we'd just transformed give a cue to show the new stats
		--  (let's not be assholes about it hehe)
		local STAT_DISPLAY_DURATION= (1*TICRATE+TICRATE/3)
		if real_time and real_time < STAT_DISPLAY_DURATION and leveltime>=(GO_TIME+TICRATE) then
			local t= p.is_actually_a_ditto.copied_target

			if t and t.valid and t.mo and
				not ( (p.HMRs) and (
						p.ditto_config~=nil 
						and p.ditto_config & DITTO_CONFIG.KEEP_HM_RESTAT)
					)
			then
				local str_speed= (t.HMRs and "\130" or "")..p.kartspeed
				local str_weight= (t.HMRs and "\130" or "")..p.kartweight
				local w_sspeed= v.stringWidth(str_speed)
				local w_sweight= v.stringWidth(str_weight)

				local d= (real_time/(TICRATE/5) + 1)
				local xs, ys= (screen_x-((3+d)/xdiv)-(w_sspeed/2)), (screen_y-(d/ydiv))
				local xw, yw= (screen_x+((3+d)/xdiv)-(w_sweight/2)), (screen_y+((6+d)/ydiv))

				local flag= V_40TRANS + (4*real_time/STAT_DISPLAY_DURATION)*V_10TRANS

				v.drawString(xs, ys, str_speed, flag | splitflags)
				v.drawString(xw, yw, str_weight, flag | splitflags)
			end
		end
	end
end

-- let's draw the stuff on the hud when we need it!
hud.add(function(v, player, camera)
	-- oh right! make sure we have all the sprite patch we need before anything else
	if not a_copyIndicator then
		a_copyIndicator= {}
		for i=0,9 do
			table.insert(a_copyIndicator,v.cachePatch("DITPRG"..i))
		end
	end


	if (not (player and player.mo and player.mo.valid)) or finished(player) then return end

	local ditto_prop= player.is_actually_a_ditto
	if not ditto_prop then return end	


	-- this was for debug only
	-- dittoDebug_transfoDataHudDisplay(v,player)

	-- okay, let's draw the ditto HUD stuff now
	drawCopyProgress(v, player, camera)
end)


-- meh
addHook("NetVars", function(net)
	_cleaning= net($)
end)
